package org.jeecg.modules.app.controller.stadium;


import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.jeecg.modules.app.service.IDetailService;
import org.jeecg.modules.app.vo.PlaceInfoVO;
import org.jeecg.modules.app.vo.stadium.StadiumConcertsResponseVO;
import org.jeecg.modules.app.vo.stadium.StadiumFindById;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


@Slf4j
@Tag(name = "App体育馆场次选择")
@RestController
@RequestMapping("/app/stadium")
public class StadiumController {

    @Autowired
    IDetailService iDetailService;


    /**
     * @Description 体育馆场次查询
     * @Date 19:41 2025/7/11
     * @Param id 门店id
     * @return PlaceInfoVO {@link PlaceInfoVO}
     **/
    @GetMapping("/getPlaceInfo")
    @Operation(summary = "场次详情查询-缺少已定状态和可预约数逻辑 ")
    public Result<StadiumConcertsResponseVO> findConcerts(StadiumFindById stadiumFindById){
        String site_id = "1942781931946946561";
        String category_id = "1942391828774895617";
        return iDetailService.findConcerts(site_id,category_id);
    }

}
