package org.jeecg.modules.app.dto;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * 家庭成员
 */
@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@Schema(description="APP添加家庭成员请求入参")
public class AddFamilyMembersDTO {


    @Schema(description = "id")
    private String id;
    /**姓名*/
    @Schema(description = "姓名")
    private String fullName;
    /**用户编号*/
    @Schema(description = "用户编号")
    private String userId;
    /**身份证号*/
    @Schema(description = "身份证号")
    private String identityCard;
    /**身份证正面照*/
    @Schema(description = "身份证正面照")
    private String idCardFrontImg;
    /**身份证反面照*/
    @Schema(description = "身份证反面照")
    private String idCardBackImg;
    /**手机号*/
    @Schema(description = "手机号")
    private String phone;
    /**实名状态 0-未实名 ；1-已实名*/
    @Schema(description = "实名状态 0-未实名 ；1-已实名，默认未实名")
    private Integer realNameStatus;
    /**身份证反面照*/
    @Schema(description = "实名认证照片")
    private String realNameImg;

    /**实名状态 0-未实名 ；1-已实名*/
    @Schema(description = "用户类型0-本人；1-家人 默认家人")
    private Integer userType;

}
