package org.jeecg.modules.app.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.NotNull;
import java.util.Date;

/**
 * 意见反馈
 */
@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@Schema(description="APP意见反馈请求入参")
public class AppSubmitFeedbackRequestDTO {

    /**用户id*/
    @Schema(description = "用户id")
    private String userId;
    /**反馈类型0-投诉吐槽；1-功能异常；2-用户体验；3-功能建议；4-其他*/
    @NotNull(message = "反馈类型不允许为空")
    @Schema(description = "反馈类型0-投诉吐槽；1-功能异常；2-用户体验；3-功能建议；4-其他")
    private Integer feedbackType;
    /**反馈描述*/
    @NotNull(message = "反馈描述不允许为空")
    @Schema(description = "反馈描述")
    private String feedbackDescribed;
    /**反馈图片地址，使用；进行隔开*/
    @Schema(description = "反馈图片地址，使用；进行隔开")
    private String feedbackImg;
    /**创建时间*/
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "创建时间")
    private Date createTime=new Date();
}
