package org.jeecg.modules.app.dto.evaluate;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 评论
 */
@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@Schema(description="APP添加评论请求入参")
public class AddEvaluateDTO {
    /**部门编码*/
    @Schema(description = "部门编码")
    private String orgCode;
    /**关联部门id*/
    @Schema(description = "关联部门id")
    private String deptId;
    /**场地/地点*/
    @Schema(description = "场地/地点")
    private Integer siteId;
    /**用户*/
    @Schema(description = "用户")
    private String userId;
    /**订单*/
    @Schema(description = "订单")
    private String orderId;
    /**评分 存储整数  1-5*/
    @Schema(description = "评分 存储整数  1-5")
    private Integer score;
    /**评价内容*/
    @Schema(description = "评价内容")
    private String evaluateContent;
    /**图片列表使用；进行隔开*/
    @Schema(description = "图片列表使用,进行隔开")
    private String images;

    /**业务类型;0场地 1课程*/
    @Schema(description = "业务类型;0场地 1课程")
    private Integer type;
    /**创建时间;创建时间*/
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "创建时间;创建时间")
    private Date createTime;


}
