package org.jeecg.modules.app.service;

import org.jeecg.modules.app.esign.exception.EsignDemoException;

public interface IESignService {
    /**
     * @Author SheepHy
     * @Description 查询用户授权状态
     * @Date 9:42 2025/7/18
     * @Param phoneNumber
     * @return boolean
     **/
    boolean getUserIdentityInfo(String phoneNumber) throws EsignDemoException;

    /**
     * @Author SheepHy
     * @Description 获取授权链接
     * @Date 9:42 2025/7/18
     * @Param
     * @return
     **/
    String getAuthUrl(String phoneNumber) throws EsignDemoException;


    /**
     * @Author SheepHy
     * @Description 查询企业授权状态
     * @Date 13:33 2025/7/18
     * @Param
     * @return
     **/
    boolean getOrgIdentityInfos(String orgName) throws EsignDemoException;

    /**
     * @Author SheepHy
     * @Description 企业获取授权链接
     * @Date 13:33 2025/7/18
     * @Param
     * @return
     **/
    String getOrgAuthUrls(String orgName,String phoneNumber) throws EsignDemoException;
}
