package org.jeecg.modules.app.service.impl;

import com.google.gson.JsonObject;
import lombok.extern.log4j.Log4j2;
import org.jeecg.modules.app.esign.comm.EsignHttpResponse;
import org.jeecg.modules.app.esign.exception.EsignDemoException;
import org.jeecg.modules.app.service.IESignService;
import org.springframework.stereotype.Service;

import static com.alibaba.dashscope.utils.JsonUtils.gson;
import static org.jeecg.modules.app.esign.auth.AuthDemo.*;

@Service
@Log4j2
public class ESignServiceImpl implements IESignService {
    @Override
    public boolean getUserIdentityInfo(String phoneNumber) throws EsignDemoException {
        EsignHttpResponse getPsnIdentityInfo = getPsnIdentityInfo(phoneNumber);
        JsonObject getPsnIdentityInfoObject = gson.fromJson(getPsnIdentityInfo.getBody(), JsonObject.class);
        String realnameStatus =getPsnIdentityInfoObject.getAsJsonObject("data").get("realnameStatus").getAsString();//授权状态authorizeUserInfo
        return realnameStatus.equals("1");
    }

    @Override
    public String getAuthUrl(String phoneNumber) throws EsignDemoException {
        EsignHttpResponse getPsnAuthUrl = getPsnAuthUrl(phoneNumber);
        JsonObject getPsnAuthUrlObject = gson.fromJson(getPsnAuthUrl.getBody(), JsonObject.class);
        JsonObject data = getPsnAuthUrlObject.getAsJsonObject("data");
        return data.get("authUrl").getAsString();
    }

    @Override
    public boolean getOrgIdentityInfos(String orgName) throws EsignDemoException {
        EsignHttpResponse getOrgIdentityInfo = getOrgIdentityInfo(orgName);
        JsonObject getOrgIdentityInfoObject = gson.fromJson(getOrgIdentityInfo.getBody(), JsonObject.class);
        String orgRealnameStatus =	getOrgIdentityInfoObject.getAsJsonObject("data").get("realnameStatus").getAsString();//授权状态authorizeUserInfo
        return orgRealnameStatus.equals("1");
    }

    @Override
    public String getOrgAuthUrls(String orgName,String phoneNumber) throws EsignDemoException {
        EsignHttpResponse getOrgAuthUrl = getOrgAuthUrl(orgName,phoneNumber);
        JsonObject getOrgAuthUrlObject = gson.fromJson(getOrgAuthUrl.getBody(), JsonObject.class);
        return getOrgAuthUrlObject.getAsJsonObject("data").get("authUrl").getAsString();
    }

}

