package org.jeecg.modules.app.vo;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.math.BigDecimal;
import java.util.List;

@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@Schema(description="教练信息返回参数")
public class InstructorVO {
    @Schema(description = "主键id")
    private String id;
    @Schema(description = "教练名称")
    private String name;
    @Schema(description = "教练头像")
    private String avatar;
    @Schema(description = "所属部门名称")
    private String orgName;
    @Schema(description = "教学理念")
    private String teachingPhilosophy;
    @Schema(description = "好评率")
    private BigDecimal goodRate;
    @Schema(description = "订单数")
    private String orderCount;
    @Schema(description = "授课人数")
    private Integer teachingCount;
    @Schema(description = "擅长说明")
    private String excelMsg;
    @Schema(description = "培训项目")
    private String trainingPrograms;
    private List<String> list;
    @Schema(description = "课程列表")
    private List<CourseInfoVO> courseList;

    @Data
    @Accessors(chain = true)
    @EqualsAndHashCode(callSuper = false)
    @Schema(description="教练课程信息返回参数")
    public static class CourseInfoVO {
        @Schema(description = "主键id")
        private String id;
        @Schema(description = "课程名称")
        private String name;
        @Schema(description = "课程价格")
        private BigDecimal sellingPrice;
        @Schema(description = "课程类型")
        private String type;
        @Schema(description = "课程简介")
        private String intro;
        @Schema(description = "课程数量")
        private int count;
    }

}
