package org.jeecg.modules.app.vo;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.math.BigDecimal;
import java.util.List;

@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@Schema(description="场地分页返回参数")
public class PlaceVO extends Page<PlaceVO> {
    @Schema(description = "id")
    private String id;
    @Schema(description = "场地名称")
    private String name;
    @Schema(description = "好评率")
    private BigDecimal goodRate;
    @Schema(description = "评论数")
    private String comments;
    @Schema(description = "地址")
    private String address;
    @Schema(description = "图片")
    private String cover;
    @Schema(description = "门店类型 0学校 1体育馆包场 ")
    private int type;
    @Schema(description = "距离(KM)")
    private double km;
    @Schema(description = "是否有票")
    private boolean ticketWhether;
    @Schema(description = "类目")
    private List<String> category;
    @Schema(hidden = true)
    private String categoryId;
    @Schema(description ="经度")
    private BigDecimal longitude;
    @Schema(description ="纬度")
    private BigDecimal latitude;

}
