package org.jeecg.modules.app.vo.coach;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecg.modules.app.vo.course.CourseResponseVo;

import java.math.BigDecimal;
import java.util.List;

@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@Schema(description="教练详情信息")
public class AppCoachDetailsVO {
    @Schema(description = "教练主键id")
    private String id;
    @Schema(description = "教练姓名")
    private String realname;
    @Schema(description = "教练头像")
    private String avatar;
    @Schema(description = "教练头像")
    private String backgroundImg;
    @Schema(description = "所教项目编号使用,分割")
    private String trainingPrograms;
    @Schema(description = "所教项目使用,分割")
    private String trainingProgramsName;
    /**好评率*/
    @Schema(description = "好评率")
    private BigDecimal goodRate;
    /**授课人数*/
    @Schema(description = "授课人数")
    private Integer classesNumber;
    /**教学理念*/
    @Schema(description = "教学理念")
    private String teachingPhilosophy;
    /**头部显示*/
    @Schema(description = "头部显示")
    private String headDisplay="已实名，无犯罪记录，健康证";
    /**擅长说明*/
    @Schema(description = "擅长说明")
    private String excelMsg;
    /**无犯罪证明*/
    @Schema(description = "无犯罪证明")
    private String certificateInnocence;
    /**健康证*/
    @Schema(description = "健康证")
    private String healthy;
    /**荣誉证书多个逗号分隔*/
    @Schema(description = "荣誉证书多个逗号分隔")
    private String honor;
    @Schema(description = "荣誉证书多个逗号分隔")
    private List<String> honorImgList;
    @Schema(description = "课程信息列表")
    private List<CourseResponseVo> courseInfoVOList;

}
