package org.jeecg.modules.app.vo.course;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecg.modules.app.dto.PageDTO;

import java.math.BigDecimal;

@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@Schema(description="查询课时分页查询入参DTO")
public class CourseRequestVo extends PageDTO {

    //教练id
    @Schema(description = "教练id")
    private String instructorId;

    //教练id
    @Schema(description = "场地id")
    private String siteId;

    //教练id
    @Schema(description = "费用类型")
    private Integer priceType;

    //教练id
    @Schema(description = "用户经度")
    private BigDecimal longitude;

    @Schema(description = "用户纬度")
    private BigDecimal latitude;

    @Schema(description = "排序方式 0-时间倒序,1-距离排序,2-销量排序,3-根据好评排序")
    private Integer orderByType;
}
