package org.jeecg.modules.app.vo.course;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecg.modules.app.dto.PageDTO;

import java.math.BigDecimal;
import java.util.Date;

@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@Schema(description="查询课时分页查询入参DTO")
public class CourseResponseVo extends PageDTO {

    @Schema(description = "课程id")
    private String id;
    @Schema(description = "场地id")
    private String address;
    @Schema(description = "原价")
    private BigDecimal originalPrice;
    @Schema(description = "售价")
    private BigDecimal sellingPrice;
    @Schema(description = "课程名称")
    private String name;

    @Schema(description = "课程封面")
    private String cover;
    @Schema(description = "费用类型")
    private String priceType;
    @Schema(description = "好评率")
    private String goodRate;
    @Schema(description = "纬度")
    private BigDecimal latitude;
    @Schema(description = "经度")
    private BigDecimal longitude;
    @Schema(description = "课时数")
    private Integer coursesNum;
    @Schema(description = "开始时间")
    private Date startTime;
    @Schema(description = "结束时间")
    private Date endTime;
    @Schema(description = "年销售数")
    private Integer annualSalesNum;
    @Schema(description = "已销售数")
    private Integer saleNum;
    @Schema(description = "用户是否第一次购买")
    private Integer isOneBuy;
    @Schema(description = "距离")
    private Double km;

}
