package org.jeecg.modules.system.app.dto;

import io.swagger.v3.oas.annotations.media.ArraySchema;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;
import org.jeecg.modules.system.app.entity.AppOrder;
import org.jeecg.modules.system.app.entity.AppOrderProduct;

import java.util.List;

/**
 * @author DM
 * @date 2025/7/7 14:29
 * @description
 */
@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@AllArgsConstructor
@NoArgsConstructor
@Schema(description="订单入参DTO")
public class AppOrderDTO {
    private AppOrder order;
    @ArraySchema(schema = @Schema(implementation = AppOrderProduct.class), minItems = 1)
    /**
     * 订单中产品id列表
     */
    @Schema(description = "订单中产品id列表")
    private List<String> orderProductList;
    @ArraySchema(schema = @Schema(implementation = AppOrderUserDTO.class), minItems = 1)
    private List<AppOrderUserDTO> orderUserList;
}