package org.jeecg.modules.system.app.dto;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotNull;

/**
 * 审核
 */
@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@AllArgsConstructor
@NoArgsConstructor
@Schema(description="审核请求入参")
public class AuditRequestDTO {

    /**主键id*/
    @Schema(description = "主键id")
    @NotNull(message = "未选择需要审核的数据")
    private String id;

    /**审核状态;0初始 1通过 2拦截*/
    @Schema(description = "审核状态;0初始 1通过 2拦截")
    @NotNull(message = "审核状态不能为空")
    private Integer checkStatus;




}
