package org.jeecg.modules.system.app.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * c端用户
 */
@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@AllArgsConstructor
@NoArgsConstructor
@Schema(description="C端用户请求入参")
public class FindPageCUserInfoResponseDTO {

    //用户昵称
    @Schema(description = "用户id")
    private String id;
    //用户昵称
    @Schema(description = "用户昵称")
    private String username;
    //实名状态 0-未实名 ；1-已实名
    @Schema(description = "实名状态 0-未实名 ；1-已实名")
    private Integer realNameStatus;
    @Schema(description = "头像")
    private String avatar;
    @Schema(description = "手机号")
    private String phone;
    @Schema(description = "家庭成员数(包括自己)")
    private Integer familyNum;
    /**创建时间*/
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "创建时间")
    private Date createTime;
}
