package org.jeecg.modules.system.app.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;
import java.util.List;

/**
 * 意见反馈
 */
@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@AllArgsConstructor
@NoArgsConstructor
@Schema(description="意见反馈返回参数")
public class FindResponseDTO {

    @Schema(description = "主键id")
    private String id;
    /**用户id*/
    @Excel(name = "用户名称", width = 15)
    @Schema(description = "用户名称")
    private String userName;
    /**用户手机号*/
    @Excel(name = "用户手机号", width = 15)
    @Schema(description = "用户手机号")
    private String phone;
    /**反馈类型0-投诉吐槽；1-功能异常；2-用户体验；3-功能建议；4-其他*/
    @Excel(name = "反馈类型0-投诉吐槽；1-功能异常；2-用户体验；3-功能建议；4-其他", width = 15)
    @Schema(description = "反馈类型0-投诉吐槽；1-功能异常；2-用户体验；3-功能建议；4-其他")
    private Integer feedbackType;

    @Schema(description = "反馈类型描述")
    private String feedbackName;
    /**反馈描述*/
    @Excel(name = "反馈描述", width = 15)
    @Schema(description = "反馈描述")
    private String feedbackDescribed;
    /**反馈图片地址，使用；进行隔开*/
    @Excel(name = "反馈图片地址，使用；进行隔开", width = 15)
    @Schema(description = "反馈图片地址，使用；进行隔开")
    private String feedbackImg;
    /**回复状态0-未回复 1-已回复*/
    @Excel(name = "回复状态0-未回复 1-已回复", width = 15)
    @Schema(description = "回复状态0-未回复 1-已回复")
    private Integer replyStatus;
    /**回复内容*/
    @Excel(name = "回复内容", width = 15)
    @Schema(description = "回复内容")
    private String replyContent;

    /**回复内容*/
    @Schema(description = "头像")
    private String avatar;

    /**创建时间*/
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "创建时间")
    private Date createTime;

    @Schema(description = "图片集合")
    private List<String> feedbackImgList;


}
