package org.jeecg.modules.system.app.dto.evaluate;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;

/**
 * 评价管理
 */
@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@AllArgsConstructor
@NoArgsConstructor
@Schema(description="评价请求入参")
public class FindEvaluateRequestDTO {

    /**评分 存储整数  1-5*/
    @Schema(description = "评分 存储整数  1-5")
    private Integer score;

    /**审核状态;0初始 1通过 2拦截*/
    @Schema(description = "审核状态;0初始 1通过 2拦截")
    private Integer checkStatus;

    /**回复状态*/
    @Schema(description = "回复状态 0-未回复 1-已回复")
    private Integer replyStatus;
    /**发布单位*/
    @Excel(name = "发布单位", width = 15)
    @Schema(description = "发布单位")
    private String deptId;

    /**部门编码*/
    @Excel(name = "部门编码", width = 15)
    @Schema(description = "部门编码")
    private String orgCode;

    /**创建时间;创建时间*/
    @Schema(description = "提交开始时间")
    private String startTime;

    /**创建时间;创建时间*/
    @Schema(description = "提交结束时间")
    private String endTime;

}
