package org.jeecg.modules.system.app.dto.evaluate;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;
import java.util.List;

/**
 * 评价
 */
@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@AllArgsConstructor
@NoArgsConstructor
@Schema(description="评价返回参数")
public class FindEvaluateResponseDTO {
    /**id*/
    @Schema(description = "id")
    private String id;
    /**部门编码*/
    @Excel(name = "部门编码", width = 15)
    @Schema(description = "部门编码")
    private String orgCode;
    /**关联部门id*/
    @Excel(name = "发布单位名称", width = 15)
    @Schema(description = "发布单位名称")
    private String departName;
    /**场地/地点*/
    @Schema(description = "场地/地点")
    private String address;
    /**用户*/
    @Schema(description = "用户")
    private String username;
    /**用户*/
    @Schema(description = "用户手机号")
    private String phone;
    /**用户头像*/
    @Schema(description = "头像")
    private String avatar;
    /**评分 存储整数  1-5*/
    @Schema(description = "评分 存储整数  1-5")
    private Integer score;
    /**评价内容*/
    @Schema(description = "评价内容")
    private String evaluateContent;
    /**图片列表使用；进行隔开*/
    @Schema(description = "图片列表使用；进行隔开")
    private String images;
    /**审核状态;0初始 1通过 2拦截*/
    @Schema(description = "审核状态;0初始 1通过 2拦截")
    private Integer checkStatus;
    /**回复状态*/
    @Schema(description = "回复状态 0-未回复 1-已回复")
    private Integer replyStatus;
    /**回复内容*/
    @Schema(description = "回复内容")
    private String replyContent;
    /**回复时间*/
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "回复时间")
    private Date replyTime;
    /**业务类型;0场地 1课程*/
    @Schema(description = "业务类型;0场地 1课程")
    private Integer type;
    /**创建时间;创建时间*/
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "创建时间;创建时间")
    private Date createTime;
    /**更新时间;更新时间*/
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "更新时间;更新时间")
    private Date updateTime;

    @Schema(description = "图片列表集合")
    private List<String> imageList;

}
