package org.jeecg.modules.system.app.dto.merchant;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotNull;

/**
 * 商户
 */
@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@AllArgsConstructor
@NoArgsConstructor
@Schema(description="添加商户参数")
public class AddMerchantRequestDTO {

    /**商户名称*/
    @Schema(description = "id")
    private String id;
    /**商户名称*/
    @NotNull(message = "商户名称不允许为空")
    @Schema(description = "商户名称")
    private String merchantName;

    /**管理员名称*/
    @NotNull(message = "管理员名称不允许为空")
    @Schema(description = "管理员名称")
    private String realName;

    /**管理员手机号*/
    @NotNull(message = "管理员手机号不允许为空")
    @Schema(description = "管理员手机号")
    private String phone;

}
