package org.jeecg.modules.system.app.dto.merchant;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 评价
 */
@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@AllArgsConstructor
@NoArgsConstructor
@Schema(description="商户返回参数")
public class FindMerchantResponseDTO {
    /**id*/
    @Schema(description = "id")
    private String id;
    /**商户名称*/
    @Schema(description = "商户名称")
    private String merchantName;
    /**关联部门id*/
    @Schema(description = "门店数")
    private Integer storeNum;
    /**管理员姓名*/
    @Schema(description = "管理员姓名")
    private String realname;
    /**用户*/
    @Schema(description = "管理员手机号")
    private String phone;
    /**创建时间;创建时间*/
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "创建时间;创建时间")
    private Date createTime;

}
