package org.jeecg.modules.system.app.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecg.common.aspect.annotation.Dict;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;

/**
 * @Description: 首页轮播图管理
 * @Version: V1.0
 */
@Data
@TableName("nm_app_banner")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
public class AppBanner implements Serializable {
    private static final long serialVersionUID = 1L;

	/**主键id*/
	@TableId(type = IdType.ASSIGN_ID)
    @Schema(description = "主键id")
    private String id;
    @Excel(name = "标题", width = 15)
    @Schema(description = "标题")
    private String title;
	/**事件类型（0: 网页链接, 1: 内部页面跳转）*/
	@Excel(name = "事件类型（0: 网页链接, 1: 内部页面跳转）", width = 15, dicCode = "event_type")
	@Dict(dicCode = "event_type")
    @Schema(description = "事件类型（0: 网页链接, 1: 内部页面跳转）")
    private String eventType;
	/**事件值*/
	@Excel(name = "事件值", width = 15)
    @Schema(description = "事件值")
    private String eventValue;
	/**图片地址*/
	@Excel(name = "图片地址", width = 15)
    @Schema(description = "图片地址")
    private String imageUrl;
	/**是否启用（0: 否，1: 是）*/
	@Excel(name = "是否启用（0: 否，1: 是）", width = 15)
    @Schema(description = "是否启用（0: 否，1: 是）")
    private String isEnabled;
	/**排序*/
	@Excel(name = "排序", width = 15)
    @Schema(description = "排序")
    private Integer sortOrder;
	/**创建人*/
    @Schema(description = "创建人")
    private String createBy;
	/**创建日期*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "创建日期")
    private java.util.Date createTime;
	/**更新人*/
    @Schema(description = "更新人")
    private String updateBy;
	/**更新日期*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "更新日期")
    private java.util.Date updateTime;
	/**所属部门*/
    @Schema(description = "所属部门")
    private String sysOrgCode;
	/**删除状态(0-正常,1-已删除)*/
	@Excel(name = "删除状态(0-正常,1-已删除)", width = 15)
    @Schema(description = "删除状态(0-正常,1-已删除)")
    @TableLogic
    private Integer delFlag;
}
