package org.jeecg.modules.system.app.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;

/**
 * @Description: 课程/培训表
 * @Author: jeecg-boot
 * @Date:   2025-07-03
 * @Version: V1.0
 */
@Data
@TableName("nm_courses")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@Schema(description="课程/培训表")
public class AppCourses implements Serializable {
    private static final long serialVersionUID = 1L;

    /**id*/
    @TableId(type = IdType.ASSIGN_ID)
    @Schema(description = "id")
    private java.lang.String id;
    /**部门编码*/
    @Excel(name = "部门编码", width = 15)
    @Schema(description = "部门编码")
    private java.lang.String orgCode;
    @Excel(name = "上课地址", width = 15)
    @Schema(description = "上课地址")
    private java.lang.String addressSiteId;
    /**教练id（关联用户表）*/
    @Excel(name = "教练id（关联用户表）", width = 15)
    @Schema(description = "教练id（关联用户表）")
    private java.lang.String userId;
    /**关联部门id*/
    @Excel(name = "关联部门id", width = 15)
    @Schema(description = "关联部门id")
    private java.lang.String tenantId;
    /**产品名称*/
    @Excel(name = "产品名称", width = 15)
    @Schema(description = "产品名称")
    private java.lang.String name;
    /**类目;0足球 1篮球 2羽毛球 3跑步...仅包场*/
    @Excel(name = "类目;0足球 1篮球 2羽毛球 3跑步...仅包场", width = 15)
    @Schema(description = "类目;0足球 1篮球 2羽毛球 3跑步...仅包场")
    private java.lang.String categoryId;
    /**费用类型;0 精品 1免费 仅课程*/
    @Excel(name = "费用类型;0 精品 1免费 仅课程", width = 15)
    @Schema(description = "费用类型;0 精品 1免费 仅课程")
    private java.lang.Integer priceType;
    /**上课场地*/
    @Excel(name = "门店信息ID", width = 15)
    @Schema(description = "门店信息ID")
    private java.lang.String siteId;
    /**保险id;可能有多个险种*/
    @Excel(name = "保险id;可能有多个险种", width = 15)
    @Schema(description = "保险id;可能有多个险种")
    private java.lang.String insureIds;
    /**封面*/
    @Excel(name = "封面", width = 15)
    @Schema(description = "封面")
    private java.lang.String cover;
    /**背景图;可能数组*/
    @Excel(name = "背景图;可能数组", width = 15)
    @Schema(description = "背景图;可能数组")
    private java.lang.String backgroundImage;
    /**原价*/
    @Excel(name = "原价", width = 15)
    @Schema(description = "原价")
    private java.math.BigDecimal originalPrice;
    /**售价*/
    @Excel(name = "售价", width = 15)
    @Schema(description = "售价")
    private java.math.BigDecimal sellingPrice;
    /**适用人群*/
    @Excel(name = "适用人群", width = 15)
    @Schema(description = "适用人群")
    private java.lang.String fitPeople;
    /**服务详情*/
    @Excel(name = "服务详情", width = 15)
    @Schema(description = "服务详情")
    private java.lang.String details;
    /**开始时间*/
    @Excel(name = "开始时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "开始时间")
    private java.util.Date startTime;
    /**结束时间*/
    @Excel(name = "结束时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "结束时间")
    private java.util.Date endTime;
    /**限购次数*/
    @Excel(name = "限购次数", width = 15)
    @Schema(description = "限购次数")
    private java.lang.Integer limitNum;
    /**提示/须知*/
    @Excel(name = "提示/须知", width = 15)
    @Schema(description = "提示/须知")
    private java.lang.String reminder;
    /**上架状态;0上架 1下架*/
    @Excel(name = "上架状态;0上架 1下架", width = 15)
    @Schema(description = "上架状态;0上架 1下架")
    private java.lang.Integer rackingStatus;
    /**视频*/
    @Excel(name = "视频", width = 15)
    @Schema(description = "视频")
    private java.lang.String video;
    /**排序*/
    @Excel(name = "排序", width = 15)
    @Schema(description = "排序")
    private java.lang.Integer sort;
    /**好评率*/
    @Excel(name = "好评率", width = 15)
    @Schema(description = "好评率")
    private java.math.BigDecimal goodRate;
    /**课程进展状态*/
    @Excel(name = "课程进展状态", width = 15)
    @Schema(description = "课程进展状态")
    private java.lang.Integer coursesStatus;
    /**系统状态;状态（0-正常,1-冻结）*/
    @Excel(name = "系统状态;状态（0-正常,1-冻结）", width = 15)
    @Schema(description = "系统状态;状态（0-正常,1-冻结）")
    private java.lang.Integer status;
    /**删除标志;删除状态(0-正常,1-已删除)*/
    @Excel(name = "删除标志;删除状态(0-正常,1-已删除)", width = 15)
    @Schema(description = "删除标志;删除状态(0-正常,1-已删除)")
    @TableLogic
    private java.lang.Integer delFlag;
    /**乐观锁*/
    @Excel(name = "乐观锁", width = 15)
    @Schema(description = "乐观锁")
    private java.lang.Integer revision;
    /**创建人;创建人*/
    @Schema(description = "创建人;创建人")
    private java.lang.String createBy;
    /**创建时间;创建时间*/
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "创建时间;创建时间")
    private java.util.Date createTime;
    /**更新人;更新人*/
    @Schema(description = "更新人;更新人")
    private java.lang.String updateBy;
    /**更新时间;更新时间*/
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "更新时间;更新时间")
    private java.util.Date updateTime;
}
