package org.jeecg.modules.system.app.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableLogic;
import org.jeecg.common.constant.ProvinceCityArea;
import org.jeecg.common.util.SpringContextUtils;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: 评价表
 * @Author: jeecg-boot
 * @Date:   2025-07-03
 * @Version: V1.0
 */
@Data
@TableName("nm_evaluate")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@Schema(description="评价表")
public class AppEvaluate implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @Schema(description = "id")
    private String id;
	/**部门id*/
	@Excel(name = "部门id", width = 15)
    @Schema(description = "部门id")
    private String orgCode;
	/**商户id/场地id*/
	@Excel(name = "商户id/场地id", width = 15)
    @Schema(description = "商户id/场地id")
    private String tenantId;
	/**用户*/
	@Excel(name = "用户", width = 15)
    @Schema(description = "用户")
    private String userId;
	/**订单*/
	@Excel(name = "订单", width = 15)
    @Schema(description = "订单")
    private String ordreId;
	/**评分*/
	@Excel(name = "评分", width = 15)
    @Schema(description = "评分")
    private BigDecimal score;
	/**评价内容*/
	@Excel(name = "评价内容", width = 15)
    @Schema(description = "评价内容")
    private String evaluateContent;
	/**图片列表*/
	@Excel(name = "图片列表", width = 15)
    @Schema(description = "图片列表")
    private String images;
	/**审核状态;0初始 1通过 2拦截*/
	@Excel(name = "审核状态;0初始 1通过 2拦截", width = 15)
    @Schema(description = "审核状态;0初始 1通过 2拦截")
    private Integer checkStatus;
	/**回复内容*/
	@Excel(name = "回复内容", width = 15)
    @Schema(description = "回复内容")
    private String replyContent;
	/**回复时间*/
	@Excel(name = "回复时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "回复时间")
    private Date replyTime;
	/**业务类型;0场地 1课程*/
	@Excel(name = "业务类型;0场地 1课程", width = 15)
    @Schema(description = "业务类型;0场地 1课程")
    private Integer type;
	/**乐观锁*/
	@Excel(name = "乐观锁", width = 15)
    @Schema(description = "乐观锁")
    private Integer revision;
	/**创建人;创建人*/
    @Schema(description = "创建人;创建人")
    private String createBy;
	/**创建时间;创建时间*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "创建时间;创建时间")
    private Date createTime;
	/**更新人;更新人*/
    @Schema(description = "更新人;更新人")
    private String updateBy;
	/**更新时间;更新时间*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "更新时间;更新时间")
    private Date updateTime;
	/**系统状态;状态(0-正常,1-冻结)*/
	@Excel(name = "系统状态;状态(0-正常,1-冻结)", width = 15)
    @Schema(description = "系统状态;状态(0-正常,1-冻结)")
    private Integer status;
	/**删除标志;删除状态(0-正常,1-已删除)*/
	@Excel(name = "删除标志;删除状态(0-正常,1-已删除)", width = 15)
    @Schema(description = "删除标志;删除状态(0-正常,1-已删除)")
    @TableLogic
    private Integer delFlag;
}
