package org.jeecg.modules.system.app.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * @Description: 意见反馈
 * @Author: jeecg-boot
 * @Date:   2025-07-07
 * @Version: V1.0
 */
@Data
@TableName("nm_feedback")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@Schema(description="意见反馈")
public class AppFeedback implements Serializable {
    private static final long serialVersionUID = 1L;

	/**主键id*/
	@TableId(type = IdType.ASSIGN_ID)
    @Schema(description = "主键id")
    private String id;
	/**用户id*/
	@Excel(name = "用户id", width = 15)
    @Schema(description = "用户id")
    private String userId;
	/**反馈类型0-投诉吐槽；1-功能异常；2-用户体验；3-功能建议；4-其他*/
	@Excel(name = "反馈类型0-投诉吐槽；1-功能异常；2-用户体验；3-功能建议；4-其他", width = 15)
    @Schema(description = "反馈类型0-投诉吐槽；1-功能异常；2-用户体验；3-功能建议；4-其他")
    private Integer feedbackType;
	/**反馈描述*/
	@Excel(name = "反馈描述", width = 15)
    @Schema(description = "反馈描述")
    private String feedbackDescribed;
	/**反馈图片地址，使用；进行隔开*/
	@Excel(name = "反馈图片地址，使用；进行隔开", width = 15)
    @Schema(description = "反馈图片地址，使用；进行隔开")
    private String feedbackImg;
	/**回复状态0-未回复 1-已回复*/
	@Excel(name = "回复状态0-未回复 1-已回复", width = 15)
    @Schema(description = "回复状态0-未回复 1-已回复")
    private Integer replyStatus;
	/**回复内容*/
	@Excel(name = "回复内容", width = 15)
    @Schema(description = "回复内容")
    private String replyContent;
	/**回复人id*/
	@Excel(name = "回复人id", width = 15)
    @Schema(description = "回复人id")
    private String replyUserId;
	/**创建时间*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "创建时间")
    private Date createTime;
	/**修改人*/
    @Schema(description = "修改人")
    private String updateBy;
	/**修改时间*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "修改时间")
    private Date updateTime;
	/**删除标志;删除状态(0-正常,1-已删除)*/
	@Excel(name = "删除标志;删除状态(0-正常,1-已删除)", width = 15)
    @Schema(description = "删除标志;删除状态(0-正常,1-已删除)")
    @TableLogic
    private Integer delFlag;
}
