package org.jeecg.modules.system.app.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @Description: 教练表
 * @Author: jeecg-boot
 * @Date:   2025-07-04
 * @Version: V1.0
 */
@Data
@TableName("nm_instructor")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@Schema(description="教练表")
public class AppInstructor implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @Schema(description = "id")
    private String id;
	/**用户id*/
	@Excel(name = "用户id", width = 15)
    @Schema(description = "用户id")
    private String userId;
	/**好评率*/
	@Excel(name = "好评率", width = 15)
    @Schema(description = "好评率")
    private BigDecimal goodRate;
	/**部门编号*/
	@Excel(name = "部门编号", width = 15)
    @Schema(description = "部门编号")
    private String orgCode;
	/**授课人数*/
	@Excel(name = "授课人数", width = 15)
    @Schema(description = "授课人数")
    private Integer classesNumber;
	/**培训项目*/
	@Excel(name = "培训项目", width = 15)
    @Schema(description = "培训项目")
    private String trainingPrograms;
	/**教学理念*/
	@Excel(name = "教学理念", width = 15)
    @Schema(description = "教学理念")
    private String teachingPhilosophy;
	/**擅长说明*/
	@Excel(name = "擅长说明", width = 15)
    @Schema(description = "擅长说明")
    private String excelMsg;
	/**系统状态;状态（0-正常,1-冻结）*/
	@Excel(name = "系统状态;状态（0-正常,1-冻结）", width = 15)
    @Schema(description = "系统状态;状态（0-正常,1-冻结）")
    private Integer status;
	/**删除标志;删除状态(0-正常,1-已删除)*/
	@Excel(name = "删除标志;删除状态(0-正常,1-已删除)", width = 15)
    @Schema(description = "删除标志;删除状态(0-正常,1-已删除)")
    @TableLogic
    private Integer delFlag;
	/**创建人;创建人*/
    @Schema(description = "创建人;创建人")
    private String createBy;
	/**创建时间;创建时间*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "创建时间;创建时间")
    private Date createTime;
	/**更新人;更新人*/
    @Schema(description = "更新人;更新人")
    private String updateBy;
	/**更新时间;更新时间*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "更新时间;更新时间")
    private Date updateTime;

    /**名称*/
    @Schema(description = "背景图")
    private String backgroundImg;
}
