package org.jeecg.modules.system.app.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * @Description: 评价管理
 * @Author: jeecg-boot
 * @Date:   2025-07-07
 * @Version: V1.0
 */
@Data
@TableName("nm_evaluate")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@Schema(description="评价管理")
public class Evaluate implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @Schema(description = "id")
    private String id;
	/**部门编码*/
	@Excel(name = "部门编码", width = 15)
    @Schema(description = "部门编码")
    private String orgCode;
	/**关联部门id*/
	@Excel(name = "关联部门id", width = 15)
    @Schema(description = "关联部门id")
    private String deptId;
	/**场地/地点*/
	@Excel(name = "场地/地点", width = 15)
    @Schema(description = "场地/地点")
    private Integer siteId;
	/**用户*/
	@Excel(name = "用户", width = 15)
    @Schema(description = "用户")
    private String userId;
	/**订单*/
	@Excel(name = "订单", width = 15)
    @Schema(description = "订单")
    private String orderId;
	/**评分 存储整数  1-5*/
	@Excel(name = "评分 存储整数  1-5", width = 15)
    @Schema(description = "评分 存储整数  1-5")
    private Integer score;
	/**评价内容*/
	@Excel(name = "评价内容", width = 15)
    @Schema(description = "评价内容")
    private String evaluateContent;
	/**图片列表使用；进行隔开*/
	@Excel(name = "图片列表使用；进行隔开", width = 15)
    @Schema(description = "图片列表使用；进行隔开")
    private String images;
	/**审核状态;0初始 1通过 2拦截*/
	@Excel(name = "审核状态;0初始 1通过 2拦截", width = 15)
    @Schema(description = "审核状态;0初始 1通过 2拦截")
    private Integer checkStatus;
	/**回复状态*/
	@Excel(name = "回复状态", width = 15)
    @Schema(description = "回复状态")
    private Integer replyStatus;
	/**回复内容*/
	@Excel(name = "回复内容", width = 15)
    @Schema(description = "回复内容")
    private String replyContent;
	/**回复人_id*/
	@Excel(name = "回复人_id", width = 15)
    @Schema(description = "回复人_id")
    private String replyUserId;
	/**回复时间*/
	@Excel(name = "回复时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "回复时间")
    private Date replyTime;
	/**业务类型;0场地 1课程*/
	@Excel(name = "业务类型;0场地 1课程", width = 15)
    @Schema(description = "业务类型;0场地 1课程")
    private Integer type;
	/**创建人;创建人*/
    @Schema(description = "创建人;创建人")
    private String createBy;
	/**创建时间;创建时间*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "创建时间;创建时间")
    private Date createTime;
	/**更新人;更新人*/
    @Schema(description = "更新人;更新人")
    private String updateBy;
	/**更新时间;更新时间*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "更新时间;更新时间")
    private Date updateTime;
	/**系统状态;状态(0-正常,1-冻结)*/
	@Excel(name = "系统状态;状态(0-正常,1-冻结)", width = 15)
    @Schema(description = "系统状态;状态(0-正常,1-冻结)")
    private Integer evaluateStatus;
	/**删除标志;删除状态(0-正常,1-已删除)*/
	@Excel(name = "删除标志;删除状态(0-正常,1-已删除)", width = 15)
    @Schema(description = "删除标志;删除状态(0-正常,1-已删除)")
    @TableLogic
    private Integer delFlag;
}
