package org.jeecg.modules.system.app.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.jeecg.modules.app.vo.PlaceInfoVO;
import org.jeecg.modules.app.vo.stadium.ConcertsVO;
import org.jeecg.modules.app.vo.stadium.StadiumConcertsResponseVO;
import org.jeecg.modules.system.app.entity.AppSitePlace;
import org.apache.ibatis.annotations.Param;
import java.util.List;

/**
 * @Description: 商户场所表
 * @Author: jeecg-boot
 * @Date:   2025-07-09
 * @Version: V1.0
 */
public interface AppSitePlaceMapper extends BaseMapper<AppSitePlace> {
    /**
     * @Author SheepHy
     * @Description 根据商户ID查询场所信息（无固定场）
     * @Date 9:38 2025/7/10
     * @Param
     * @return
     **/
    List<PlaceInfoVO.PlaceInfoGymMsgVO> getPlaceInfoNoFixation(@Param("id")String id);

    List<ConcertsVO> findByConcerts(@Param("weekDay")Integer weekDay, @Param("siteId")String siteId, @Param("categoryId")String categoryId);

    StadiumConcertsResponseVO findBySidAndCid(@Param("siteId")String siteId,@Param("categoryId") String categoryId);
}
