package org.jeecg.modules.system.app.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import org.jeecg.modules.system.app.dto.AppCoursesCuDTO;
import org.jeecg.modules.system.app.dto.AppCoursesDTO;
import org.jeecg.modules.system.app.dto.AppCoursesPageDTO;
import org.jeecg.modules.system.app.entity.AppCourses;
import com.baomidou.mybatisplus.extension.service.IService;

/**
 * @Description: 课程/培训表
 * @Author: jeecg-boot
 * @Date:   2025-07-03
 * @Version: V1.0
 */
public interface IAppCoureseService extends IService<AppCourses> {
    /**
     * 保存课程
     * @param appCoursesDTO
     * @return
     */
    Boolean saveWitchPriceRules(AppCoursesDTO appCoursesDTO);
    /**
     * 修改课程
     * @param appCoursesDTO
     * @return
     */
    Boolean editWitchPriceRules(AppCoursesCuDTO appCoursesDTO);
    /**
     * 通过id查询课程
     * @param id
     * @return
     */
    AppCoursesDTO queryWitchPriceRulesById(String id);
    /**
     * 删除课程
     * @param id
     * @return
     */
    Boolean deleteWitchPriceRulesById(String id);

    IPage<AppCoursesCuDTO> queryWitchPriceRulesPage(AppCoursesPageDTO dto);

}
