package org.jeecg.modules.system.app.service;

import org.jeecg.modules.system.app.dto.AppOrderDTO;
import org.jeecg.modules.system.app.entity.AppOrder;
import com.baomidou.mybatisplus.extension.service.IService;

/**
 * @Description: 订单表
 * @Author: jeecg-boot
 * @Date:   2025-07-03
 * @Version: V1.0
 */
public interface IAppOrderService extends IService<AppOrder> {
    /**
     * 添加订单表
     * @param appOrderDTO
     * @return
     */
    Boolean saveWitchProduct(AppOrderDTO appOrderDTO);

    /**
     * 修改订单表
     * @param appOrderDTO
     * @return
     */
    Boolean editWitchProduct(AppOrderDTO appOrderDTO);

    /**
     * 删除订单表
     * @param id
     * @return
     */
    Boolean deleteWitchProductById(String id);

    /**
     * 查询订单详情
     * @param id
     * @return
     */
    AppOrderDTO queryWitchProductById(String id);

}
