package org.jeecg.modules.system.app.vo;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;

/**
 * @author DM
 * @date 2025/7/7 17:37
 * @description
 */
@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@AllArgsConstructor
@NoArgsConstructor
@Schema(description="门店信息返回VO")
public class AppSiteListVO {
    @TableId(type = IdType.ASSIGN_ID)
    @Schema(description = "id")
    private String id;
    /**部门编码*/
    @Excel(name = "部门编码", width = 15)
    @Schema(description = "部门编码")
    private String orgCode;
    /**关联部门id*/
    @Excel(name = "关联部门id", width = 15)
    @Schema(description = "关联部门id")
    private String tenantId;
    /**名称*/
    @Excel(name = "名称", width = 15)
    @Schema(description = "名称")
    private String name;
    /**地址*/
    @Excel(name = "地址", width = 15)
    @Schema(description = "地址")
    private String address;
    /**0学校 1体育馆*/
    @Excel(name = "0学校 1体育馆", width = 15)
    @Schema(description = "0学校 1体育馆")
    private Integer type;
    /**经营状态0营业 1休息*/
    @Excel(name = "经营状态0营业 1休息", width = 15)
    @Schema(description = "经营状态0营业 1休息")
    private Integer runStatus;
}