package org.jeecg.modules.system.app.vo.staff;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * @author DM
 * @date 2025/7/7 17:37
 * @description
 */
@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@AllArgsConstructor
@NoArgsConstructor
@Schema(description="员工查询返回参数")
public class StaffResponseVO {
    @Schema(description = "id")
    private String id;
    /**名称*/
    @Schema(description = "登录账号")
    private String username;
    /**名称*/
    @Schema(description = "用户名称")
    private String realname;
    /**1-正常,2-冻结*/
    @Schema(description = "用户状态1-正常,2-冻结")
    private Integer status;

    @Schema(description = "部门")
    private String  departName;

    /**更新时间;更新时间*/
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "创建时间")
    private Date createTime;

}