package org.jeecg.modules.system.app.vo.staff;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;

/**
 * @author DM
 * @date 2025/7/7 17:37
 * @description
 */
@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@AllArgsConstructor
@NoArgsConstructor
@Schema(description="员工请求参数")
public class StaffSaveVO {

    @Schema(description = "id")
    private String id;
    /**名称*/
    @Schema(description = "登录账号")
    private String username;

    /**名称*/
    @Schema(description = "背景图")
    private String backgroundImg;
    /**地址*/
    @Schema(description = "用户名称(真实姓名)")
    private String realname;
    /**1-正常,2-冻结*/
    @Schema(description = "用户状态1-正常,2-冻结")
    private Integer status;
    /**密码*/
    @Schema(description = "密码")
    private String password;


    @Schema(description = "所属角色")
    private String  selectedroles;

    @Schema(description = "所属部门")
    private String  selecteddeparts;
    /**部门编号*/
    @Excel(name = "部门编号", width = 15)
    @Schema(description = "部门编号")
    private String orgCode;
    /**培训项目*/
    @Excel(name = "培训项目", width = 15)
    @Schema(description = "培训项目,使用,分割")
    private String trainingPrograms;
    /**教学理念*/
    @Excel(name = "教学理念", width = 15)
    @Schema(description = "教学理念")
    private String teachingPhilosophy;
    /**擅长说明*/
    @Excel(name = "擅长说明", width = 15)
    @Schema(description = "擅长说明")
    private String excelMsg;
    /**无犯罪证明*/
    @Excel(name = "无犯罪证明", width = 15)
    @Schema(description = "无犯罪证明")
    private String certificateInnocence;
    /**健康证*/
    @Excel(name = "健康证", width = 15)
    @Schema(description = "健康证")
    private String healthy;
    /**荣誉证书多个逗号分隔*/
    @Excel(name = "荣誉证书多个逗号分隔", width = 15)
    @Schema(description = "荣誉证书多个逗号分隔")
    private String honor;

}